<?php

namespace Database\Seeders;

use App\BO\BimFileBO;
use App\Models\BimFile;
use Illuminate\Database\Console\Seeds\WithoutModelEvents;
use Illuminate\Database\Seeder;

class BimModelTypeSeeder extends Seeder
{
    /**
     * Run the database seeds.
     */
    public function run(): void
    {
        BimFile::query()->where('model_type', '')->chunkById(50, function ($bimFiles) {
            foreach ($bimFiles as $bimFile) {
                $file = $bimFile->file;
                if ($file) {
                    $bimFileBO = new BimFileBO($file->extension, $file->title);
                    $bimFile->model_type = $bimFileBO->modelType;
                    $bimFile->timestamps = false;
                    $bimFile->save();

                    echo $bimFile->id . ' model_type is ' . $bimFileBO->modelType . PHP_EOL;
                }
            }
        });
    }
}
