<?php

declare(strict_types=1);

use App\Http\Middleware\GetTenancyByUsername;
use Illuminate\Support\Facades\Route;
use Stancl\Tenancy\Middleware\InitializeTenancyByDomain;
use Stancl\Tenancy\Middleware\InitializeTenancyByRequestData;
use Stancl\Tenancy\Middleware\PreventAccessFromCentralDomains;

/*
|--------------------------------------------------------------------------
| Tenant Routes
|--------------------------------------------------------------------------
|
| Here you can register the tenant routes for your application.
| These routes are loaded by the TenantRouteServiceProvider.
|
| Feel free to customize them however you want. Good luck!
|
*/

Route::middleware((function() {
    return [
        'domain' => [InitializeTenancyByDomain::class, PreventAccessFromCentralDomains::class],
        'requestData' => [GetTenancyByUsername::class, InitializeTenancyByRequestData::class, PreventAccessFromCentralDomains::class],
    ][config('tenancy.init_tenant_middleware', 'domain')];
})())->group(function () {
    Route::get('/', function () {
        return 'This is your multi-tenant application. The id of the current tenant is ' . tenant('id');
    });
});
